// ***********************************************************************
// *Licensed Materials - Property of IBM
// *5724-W86, 5724-P68
// *(C) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
// *US Government Users Restricted Rights - Use, duplication or disclosure
// *restricted by GSA ADP Schedule Contract with IBM Corp.
// ***********************************************************************


function createStreamQuery(name, inputOperator) {
        var returnOperator = PV.StreamSort(name, inputOperator, StreamQueryHandler);
        returnOperator.setPeriodDuration(900);
        returnOperator.flushAfterSeconds(600);
        return returnOperator;
}

function StreamQueryHandler(record) {

        var subelement = createElementAndSubElements(this, record);


        createMetrics(this, subelement, record);
}

function createElementAndSubElements(operator, record) {


        var element = operator.elementNamedOrNew(record.sbc_name);
                element.state = true;
                element.invariant = record.sbc_name;
                element.instance = record.sbc_name;
                element.origin = record.sbc_name;
		//                element.timestamp = record.timestamp;
        var sename = "";
        if ( input_file_hash[record.file_type].subelement_suffix_field ) {
                        sename = record.sbc_name + "_" + record.fields[input_file_hash[record.file_type].subelement_suffix_field-1];
        } else if ( input_file_hash[record.file_type].subelement_suffix ) {
                        sename = record.sbc_name + "_" + input_file_hash[record.file_type].subelement_suffix;
        }

         // added as advised by IBM for the PMR 10325,019,866
        if (null ==  input_file_hash[record.file_type])
            { PV.Logger.logWarning("UNKNOWN_FILE_TYPE", "Unknown File Type", record.file_type);
              return;
            }


        var subelement = operator.subelementNamedOrNew(sename);

                subelement.state = true;
                subelement.invariant = sename;
                subelement.instance = sename;
                subelement.family = "VOIP_Softswitch";
                subelement.label = sename;
		//                subelement.timestamp = record.timestamp;
                subelement.origin = record.sbc_name;
                subelement.element = element;

        for ( var property in input_file_hash[record.file_type].prop ) {
                if ( input_file_hash[record.file_type].prop.hasOwnProperty(property)) {
//                        if (property == "SystemType" || property == "Acme_IfDescr" || property == "Acme_IfType" ||  property == "Realm Name" || property == "Redundancy State" ||  property == "I2C Bus State") {
                        if (property == "SystemType" || property == "Acme_IfDescr") {
                           subelement.addProperty(property.toString(), record.fields[input_file_hash[record.file_type].prop[property]]);
                        } else {
                           subelement.addProperty(property.toString(), input_file_hash[record.file_type].prop[property].toString());
                        }
                }
        }
        subelement.element = element;
        return subelement;
}

function createMetrics(operator, subelement, record) {
        for ( var m in input_file_hash[record.file_type].metrics ) {
                if ( input_file_hash[record.file_type].metrics.hasOwnProperty(m)) {
                var metric = operator.FloatMetric();
                if (isValid(subelement.state)) {
                        metric.name = input_file_hash[record.file_type].metric_prefix + "~" + m;
			//                        metric.timestamp = record.timestamp;
                        metric.value = record.fields[input_file_hash[record.file_type].metrics[m] - 1];
                        metric.resource = subelement;
                        operator.addMetric(metric);
                }
                }
        }

        return null;
}
